package {

	import fl.controls.Button;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.DataEvent;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.ProgressEvent;
	import flash.events.SampleDataEvent;
	import flash.events.TimerEvent;
	import flash.filesystem.File;
	import flash.media.Camera;
	import flash.media.Microphone;
	import flash.media.SoundCodec;
	import flash.media.Video;
	import flash.net.FileFilter;
	import flash.net.FileReference;
	import flash.net.NetConnection;
	import flash.net.NetStream;
	import flash.text.TextField;
	import flash.utils.ByteArray;
	import flash.utils.getTimer;
	import flash.utils.Timer;
	import fr.kikko.lab.ShineMP3Encoder;
	import org.bytearray.micrecorder.encoder.WaveEncoder;
	import ru.cleptoman.flv.events.FLVEncoderEvent;
	import ru.cleptoman.flv.video.*;
	import ru.cleptoman.flv.audio.*;
	import ru.cleptoman.flv.FLVEncoder;

	
	public class Main extends Sprite {
		
		private const RECORD_FPS:Number			= 25;
		private const KEYFRAMES_SPACING:uint	= 50;
		
		private var _cam:Camera;
		private var _video:Video;
		private var _timer:Timer;
		private var _mic:Microphone;
		private var _sound:ByteArray;
		private var _videoTags:Vector.<FLVVideoTag>;
		private var _audioTags:Vector.<FLVAudioTag>;
		private var _timeStamp:uint;
		private var _startTime:uint;
		
		private var _statusTF:TextField;
		
		private var _flv:ByteArray;
		
		private var _flvVideoTags:FLVVideoTags;
		private var _flvAudioTags:FLVAudioTags;
		
		public function Main():void {
			_cam					= Camera.getCamera();
			
			_video					= new Video();
			_video.smoothing		= true;
			super.addChild(_video);
			
			var startRecButton:Button = new Button();
			startRecButton.label	= "записать";
			super.addChild(startRecButton);
			startRecButton.x		= 400;
			
			_statusTF				= new TextField();
			super.addChild(_statusTF);
			_statusTF.width			= 400;
			_statusTF.y				= 260;
			_statusTF.x				= 10;
			
			_mic					= Microphone.getMicrophone();
			
			if (_cam) {
				
				_videoTags			= new Vector.<FLVVideoTag>;
				_video.attachCamera(_cam);
				startRecButton.addEventListener(MouseEvent.CLICK, onStartRecord);
				
			}
			
		}
		
		private function onStartRecord(e:MouseEvent):void {
			
			_startTime				= getTimer();
			_timeStamp				= 0;
			
			var button:Button		= e.target as Button;
			button.removeEventListener(MouseEvent.CLICK, onStartRecord);
			button.addEventListener(MouseEvent.CLICK, onStopRecord);
			
			button.label			= "стоп";
			
			if (_mic) {
				_audioTags			= new Vector.<FLVAudioTag>;
				_mic.rate			= 44;
				_mic.gain			= 90;
				_sound				= new ByteArray();
				_mic.addEventListener(SampleDataEvent.SAMPLE_DATA, onMicSample);
				
			}
			
			/**
			 * каждый тик таймера будем снимать видео в битмапдату и складывать в вектор
			 */
			_timer			= new Timer(1000 / RECORD_FPS);
			_timer.addEventListener(TimerEvent.TIMER, onTimerHandler);
			_timer.start();
		}
		/**
		 * пишем каждый семпл с микрофона в буффер
		 * @param	e
		 */
		private function onMicSample(e:SampleDataEvent):void {
			_sound.writeBytes(e.data);
		}
		
		private function onStopRecord(e:MouseEvent):void {
			
			_timer.stop();
			
			var button:Button			= e.target as Button;
			button.removeEventListener(MouseEvent.CLICK, onStopRecord);
			super.removeChild(button);
			button						= null;
			
			/**
			 * если снимали данные с микрофона, формируем аудиотэг для FLV. он пока один..попытки сделать несколько (поскольку при премотке звук пропадает) ни к чему пока хорошему не привели
			 */
				
			_mic.removeEventListener(SampleDataEvent.SAMPLE_DATA, onMicSample);
			
			/**
			 * пакуем наш буффер в WAV контейнер (PCM_LITTLE_ENDIAN)
			 */
			_flvAudioTags		 = new FLVAudioTags();
			var wavencoder:WaveEncoder = new WaveEncoder(1);
			var sound:ByteArray	= wavencoder.encode(_sound, 1);
			wavencoder 			= null;
			_sound				= null;
			/**
			 * создаем тэг (просто типизированный объектик)
			 */
			var atag:FLVAudioTag	= new FLVAudioTag();
			atag.sample				= sound;
			sound					= null;
			/**
			 * задаем начало воспроизведения звука в милисекундах. тут логично ставить ноль, но, почему то видео немного отстает от звука..потому немного его подвинем
			 */
			atag.timeStamp			= 200;
			_audioTags.push(atag);

			_flvAudioTags.tags		= _audioTags;
			
			/**
			 * конфиг сделал один для всех тегов.
			 */
			var aconfig:FLVAudioConfig = new FLVAudioConfig();
			
			/**
			 * это для WAV
			 */
			/*
			aconfig.codecID		= FLVAudioCodec.PCM_LITTLE_ENDIAN;
			aconfig.soundRate	= FLVSoundRate.RATE11;
			aconfig.soundType	= FLVSoundType.MONO;
			*/
			
			aconfig.codecID		= FLVAudioCodec.MP3;
			aconfig.soundRate	= FLVSoundRate.RATE544;
			aconfig.soundType	= FLVSoundType.MONO;
			
			
			_flvAudioTags.config	= aconfig;

			/** 
			 * делаем последний видеотэг ключевым. ключевыми кадрами могут быть только видео.
			*/
			_videoTags[_videoTags.length - 1].frameType = FLVVideoFrameType.KEY_FRAME;
			
			
			_flvVideoTags = new FLVVideoTags();
			_flvVideoTags.tags			= _videoTags;
			
			/**
			 * пишем конфиг для видеотэгов. тоже один.
			 */
			var vconfig:FLVVideoConfig = new FLVVideoConfig();
			vconfig.codecID			= 3;
			vconfig.framerate		= RECORD_FPS;
			vconfig.videoHeight		= _video.height;
			vconfig.videoWidth		= _video.width;
			
			_flvVideoTags.config	= vconfig;
			
			/**
			 * энкодим наш файлик, сохраняем.
			 * нужно отметить, что метатэг так же формируется легко ручками и, в принципе, его можно вынести вне енкодера, но я оставил формирование метаинфы на совесть енкодера
			 */
			
			
			/**
			 * пакуем звук в мп3. в случае с wav ролики получаются очень большие
			 */
			var encoder2:ShineMP3Encoder = new ShineMP3Encoder(_audioTags[0].sample);
			encoder2.addEventListener(Event.COMPLETE, mp3EncodeCompleteToSave);
			encoder2.addEventListener(ProgressEvent.PROGRESS, onPackMP3ProgressHandler);
			encoder2.start();
			
		}
		
		private function onPackMP3ProgressHandler(e:ProgressEvent):void {
			_statusTF.text						= "кодируем аудио в MP3: " + String(Math.round(e.bytesLoaded / e.bytesTotal * 100)) + "%";
			
		}
		
		private function mp3EncodeCompleteToSave(e:Event):void {
			
			var encoder2:ShineMP3Encoder = e.target as ShineMP3Encoder;
			encoder2.removeEventListener(Event.COMPLETE, mp3EncodeCompleteToSave);
			encoder2.removeEventListener(ProgressEvent.PROGRESS, onPackMP3ProgressHandler);

			_flvAudioTags.tags[0].sample		= encoder2.mp3Data;
			
			var encoder:FLVEncoder	= new FLVEncoder();
			encoder.addEventListener(FLVEncoderEvent.ENCODE_PROGRESS, onProgressHandler);
			encoder.addEventListener(FLVEncoderEvent.ENCODE_COMPLETE, onCompleteHandler);
			encoder.encode(_flvVideoTags, _flvAudioTags);
		}
		
		private function onCompleteHandler(e:FLVEncoderEvent):void {
			var encoder:FLVEncoder	= e.target as FLVEncoder;
			encoder.removeEventListener(FLVEncoderEvent.ENCODE_PROGRESS, onProgressHandler);
			encoder.removeEventListener(FLVEncoderEvent.ENCODE_COMPLETE, onCompleteHandler);

			_flv					= encoder.flvFile;
			
			var saveButton:Button	= new Button();
			saveButton.label		= "сохранить";
			var playButton:Button	= new Button();
			playButton.label		= "открыть";
			
			super.addChild(saveButton);
			super.addChild(playButton);
			
			saveButton.x			= 400;
			playButton.x			= 400;
			
			playButton.y			= 50;
			
			saveButton.addEventListener(MouseEvent.CLICK, onSaveButtonClick);
			playButton.addEventListener(MouseEvent.CLICK, onPlayButtonClick);
			
			encoder					= null;
		}
		
		private function onPlayButtonClick(e:MouseEvent):void {
			var filter:FileFilter	= new FileFilter("мои записи FLV", "*.flv", "flv");
			var file:File			= new File();
			file.addEventListener(Event.SELECT, onSelectFile);
			file.browseForOpen("найди свою запись", [filter]);
		}
		
		private function onSelectFile(e:Event):void {
			var file:File			= e.target as File;
			file.removeEventListener(Event.SELECT, onSelectFile);
			var nc:NetConnection	= new NetConnection();
			nc.connect(null);
			var ns:NetStream		= new NetStream(nc);
			_video.attachNetStream(ns);
			ns.client				= { };
			ns.play(file.nativePath);
			file					= null;
		}
		
		private function onSaveButtonClick(e:MouseEvent):void {
			var file:FileReference = new FileReference();
			file.save(_flv, "record.flv");
		}
		
		private function onProgressHandler(e:FLVEncoderEvent):void {
			trace(e.percents);
			_statusTF.text						= "кодируем данные в FLV: " + String(Math.round(e.percents * 100)) + "%";
		}

		
		private function onTimerHandler(e:TimerEvent):void {
			
			/**
			 * для каждого тега основным для воспроизведения показателем является timestamp - время в милисекндах когда нужно проиграть.
			 */
			_timeStamp				= getTimer() - _startTime;
			/**
			 * сфотграфировали
			 */
			var bmp:BitmapData		= new BitmapData(_video.width, _video.height, false, 0);
			bmp.draw(_video);
			/**
			 * утрамбовали в объект тэга
			 * */
			var tag:FLVVideoTag		= new FLVVideoTag();
			var isKeyframe:Boolean	= (_videoTags.length % KEYFRAMES_SPACING === 0);
			tag.frameType			= isKeyframe? FLVVideoFrameType.KEY_FRAME : FLVVideoFrameType.INTER_FRAME;
			tag.video				= bmp;
			bmp						= null;
			tag.timeStamp			= _timeStamp;
			_videoTags.push(tag);
		}
		
	}
	
}